//+------------------------------------------------------------------+
//|                                             Close_all_orders.mq4 |
//|                                                  mentalityman    |
//| v1.1                                                             |
//+------------------------------------------------------------------+
#property copyright "mentalityman"
#property link      ""
#property show_inputs

extern bool DeleteBUY = true;
extern bool DeleteSELL = true;
extern bool CloseStopOrders = true;
extern bool CloseOrders = true;
extern bool OnlyThisSymbol = true;
extern int __ = 10;
extern int  = 2;

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
  int bufint, num=0;
  string Error = "  : ";
  DeleteAllOrders();
  return(0);
}

bool DeleteAllOrders()
{
  int bufnum;
  string Error = "  : ";
  for(int pos=OrdersTotal()-1; pos>=0; pos--)
  {
    bufnum = 0;
    if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==false) continue; 
    if(((OrderSymbol() == Symbol() && OnlyThisSymbol) || !OnlyThisSymbol)) //  ,   
    {
      if(OrderType()==OP_BUY && DeleteBUY && CloseOrders) 
      {
        if(!OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_BID), , CLR_NONE))
        { //
          Print(Error+orderErrorCodes(0));
          while(true)
          {
             bufnum++;
             RefreshRates();
             if(!OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_BID), 5, CLR_NONE)) Print("  ",bufnum, "  BUY   : ",orderErrorCodes(0));
             else {Print("  ",bufnum, "  BUY   .");break;}
             if(bufnum >= __) {Print("    ",bufnum, "   BUY      ", orderErrorCodes(0)," .");break;}
             Sleep(50*bufnum);
          }
        }
        else continue;
      }
      if(OrderType()==OP_SELL && DeleteSELL && CloseOrders) 
      {
        if(!OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_ASK), , CLR_NONE))
        { 
          Print(Error+orderErrorCodes(0));RefreshRates();
          while(true)
          {
             bufnum++;
             RefreshRates();
             if(!OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_BID), 5, CLR_NONE)) Print("  ",bufnum, "  BUY   : ",orderErrorCodes(0));
             else {Print("  ",bufnum, "  BUY   .");break;}
             if(bufnum >= __) {Print("    ",bufnum, "   BUY      ", orderErrorCodes(0)," .");break;}
             Sleep(50*bufnum);
          }
        }
        else continue;
      }
      if(OrderType()==OP_SELLSTOP && CloseStopOrders && DeleteSELL) 
      {
        if(!OrderDelete(OrderTicket()))
        { 
          Print(Error+orderErrorCodes(0));RefreshRates();
        }
      } 
      if(OrderType()==OP_BUYSTOP && CloseStopOrders && DeleteBUY) 
      {
        if(!OrderDelete(OrderTicket()))
        { 
          Print(Error+orderErrorCodes(0));RefreshRates();
        }
      }           
    }
  }
}

string orderErrorCodes(int code) //   
{
if(code == 0) code = GetLastError();
switch(code) 
    {
     case 138 : return(" ");
     case 3   : return(" ");
     case 4   : return("  ");
     case 6   : return("    ");
     case 8   : return("  ");
     case 64  : return(" ");
     case 128 : return("    ");
     case 129 : return(" ");
     case 130 : return(" ");
     case 131 : return(" ");
     case 132 : return(" ");
     case 133 : return(" ");
     case 134 : return("    ");
     case 135 : return(" ");
     case 136 : return(" ");
     case 139 : return("    ");
     case 140 : return("  ");
     case 141 : return("  ");
     case 147 : return("     ");
     case 4109: return("    .");     
     default: return("    " + code);
    }
}